| Enumerations, structures and type definitions

### CableModel

CABLE_NUL = 0,

An enumeration which contains the following cable types: /

Return value : |

### CablePort

PORT_0 = 0,

An enumeration which contains the following ports: /

Return value : |

### UsbPid

PID_UNKNOWN = 0,

An enumeration which contains the following devices: /

Return value : |

### CableStatus

STATUS_NONE = 0,

An enumeration which contains the following values: /

Return value : |

### ProbingMethod

PROBE_NONE = 0,

Defines how to probe cables: /

Return value : |

### CableFnctsIdx

CABLE_FNCT_PREPARE=0,

Index of function in the #CableFncts structure: /

Return value : |

### CableFamily

CABLE_FAMILY_UNKNOWN = 0,

Defines the various types of devices supported and which can be detected automatically; each family is generally incompatible with the others in terms of protocol, file formats, or both.

Return value : |

### CableVariant

CABLE_VARIANT_UNKNOWN = 0,

Defines the various sub-types (for a given CableFamily) that are supported and can be detected automatically.

Return value : |

### CableDeviceInfo

CableFamily family;

Information returned for each cable by ticables_get_usb_device_info.

family : | calculator family
variant : | calculator variant
Return value : |

### DataRate

int count;

A structure used for benchmarks. !!! This structure is for private use !!! /

count : | number of bytes transferred
start : | the time when transfer started
current : | free of use
stop : | the time when transfer finished
Return value : |

### Cable

const int model;

A structure used for handling a link cable. !!! This structure is for private use !!! /

model : | link cable model (CableModel).
name : | name of cable like "SER"
fullname : | complete name of cable like "BlackLink"
description : | description of cable like "serial cable"
need_open : | set if cable need to be 'open'/'close' before calling 'probe'
prepare : | detect and map I/O
probe : | check for cable presence
timeout : | used to update timeout
open : | open I/O port or device
close : | close I/O port or device
reset : | reset I/O port or device
send : | send data onto the cable
recv : | recv data from cable
check : | check for data arrival
set_d0 : | set D0/red wire
set_d1 : | set D1/white wire
get_d0 get D0/red wire : | (null)
get_d1 set D1/white wire : | (null)
set_raw : | set both wires
get_raw : | read both wires
Return value : |

### CableEventType

CABLE_EVENT_TYPE_UNKNOWN = 0,

Defines the various events fired by libticables into a registered event hook, if any.

Return value : |

### CableEventData

unsigned int version;

Information returned for every event fired by the libticables library; only a subset of the fields is valid for some event types.

version : | event protocol version.
type : | event type
retval : | return value of the operation, for "after" events.
open : | whether the cable is open.
operation : | index (CalcFnctsIdx) of the generic operation invoked by the library user, if any.
data : | data to be sent / received, if any - or user-specified data.
Return value : |

### CableHandle

CableModel model;

A structure used to store information as an handle. !!! This structure is for private use !!! /

model : | cable model
port : | generic port
timeout : | timeout value in 0.1 seconds
delay : | inter-bit delay for serial/parallel cable in us
device : | device name like COMx or ttySx (if used)
address : | I/O base address of device (if used)
cable : | a Cable structure used by this handle
rate : | data rate during transfers
priv : | opaque data for internal/private use (static)
priv2 : | idem (allocated)
priv3 : | idem (static)
open : | set if cable has been open
busy : | set if cable is busy
pre_send_hook : | callback fired before sending a block of data (deprecated).
post_send_hook : | callback fired after sending a block of data (deprecated).
pre_recv_hook : | callback fired before receiving a block of data (deprecated).
post_recv_hook : | callback fired after receiving a block of data (deprecated).
event_hook : | callback fired upon various events (replaces and expands on the deprecated callbacks).
user_pointer : | user-set pointer passed to the event callbacks.
event_count : | number of events sent since this handle was created.
Return value : |

### CableOptions

CableModel model;

A convenient structure free of use by the user. /

cable_model : | model
cable_port : | port
cable_timeout : | timeout in tenth of seconds
cable_delay : | inter-bit delay in us
calc_model : | calculator model
Return value : |

### Return to the main index